<%@ page import="org.jbpm.JbpmServiceFactory,
                 org.jbpm.ExecutionService,
                 java.util.Collection,
                 org.jbpm.model.definition.Definition,
                 java.util.List,
                 org.jbpm.JbpmQuery,
                 org.jbpm.model.execution.impl.ProcessInstanceImpl"%>
<jsp:include page="../partHeader.jsp" />
<%
  Long id = new Long(request.getParameter("id"));
  JbpmServiceFactory fact = JbpmServiceFactory.getInstance();
  ExecutionService executionService = fact.openExecutionService(null);

  String action = request.getParameter("action");
  if ("instantiate".equals(action)) {
    executionService.startProcessInstance(id);
  } else if ("cancelInstance".equals(action)) {
    Long instanceId = new Long(request.getParameter("instanceId"));
    executionService.cancelProcessInstance(instanceId);
  }

  Definition def = executionService.getDefinition(id);
  def = executionService.getLatestDefinition(def.getName());

  String hql = "select from "+ProcessInstanceImpl.class.getName()+" as p where p.definition = :definition" ;
  JbpmQuery j = new JbpmQuery( hql );
  j.addParameter("definition",def);
  // why ? it is just a less powerful version of hibernate's no ? :-(
  List instances = executionService.findByQuery(j);

      %>
        <table width="90%" align="center" border="1">
          <tr>
            <th colspan=5><big><%=def.getName()%></big> &nbsp; (total instances:<%=instances.size()%>)<br>
                          <%=def.getDescription()!=null ? def.getDescription() : "(no description)"%>
            </th>
          </tr>
          <tr>
            <th>instance id</th>
            <th>status</th>
            <th>start on</th>
            <th>end on</th>
            <th>edit</th>
          </tr>
      <%

  for (int i = 0; i < instances.size(); i++) {
    ProcessInstanceImpl processInstance = (ProcessInstanceImpl) instances.get(i);
     %>
      <tr>
        <td> <%=processInstance.getId()%> </td>
        <td> <%=processInstance.hasEnded() ? "ended" : "RUNNING"%> </td>
        <td> <%=processInstance.getStart()%> </td>
        <td> <%=processInstance.getEnd()%> </td>
        <td> <a href="instance.jsp?id=<%=processInstance.getId()%>">edit</a>
             &nbsp;<a href="flow.jsp?instanceId=<%=processInstance.getId()%>&id=<%=def.getId()%>&action=cancelInstance">end it</a>
             &nbsp;<a href="log.jsp?instanceId=<%=processInstance.getId()%>">log</a>

        </td>
      </tr>
    <%
  }

  %>
          <tr>
            <td colspan=5>
              <form action="flow.jsp" method="GET" >
                instantiate new flow "<%=def.getName()%>"
                <input type="hidden" name="id" value="<%=def.getId()%>">
                <input type="SUBMIT" name="action" value="instantiate">
              </form>
            </td>

  </tr>

    <tr>
       <td colspan=5>
      <a href="../index.jsp">home</a> &nbsp;&nbsp;
       <a href="deployList.jsp">deployed flows</a> &nbsp;&nbsp;
       <a href="nodes.jsp?id=<%=def.getId()%>">nodes</a>
     </tr>


</table>

<br><table width="90%" align="center" border="1">
<%
  hql = "select from "+ProcessInstanceImpl.class.getName()+" as p where p.definition != :def and p.definition.name = :name and p.end is null" ;
  j = new JbpmQuery( hql );
  j.addParameter("def",def);
  j.addParameter("name",def.getName());
  instances = executionService.findByQuery(j);

  if (instances!=null && instances.size()>0) {

%>

          <tr>
            <th colspan=5><big>Previous versions</big> &nbsp; (total instances of previous versions:<%=instances.size()%>)<br>
                          <%=def.getDescription()%>
            </th>
          </tr>
          <tr>
            <th>instance id</th>
            <th>status</th>
            <th>start on</th>
            <th>end on</th>
            <th>edit</th>
          </tr>

        <%

  for (int i = 0; i < instances.size(); i++) {
    ProcessInstanceImpl processInstance = (ProcessInstanceImpl) instances.get(i);
     %>
      <tr>
        <td> <%=processInstance.getId()%> </td>
        <td> <%=processInstance.hasEnded() ? "ended" : "RUNNING"%> </td>
        <td> <%=processInstance.getStart()%> </td>
        <td> <%=processInstance.getEnd()%> </td>
        <td> <a href="instance.jsp?id=<%=processInstance.getId()%>">edit</a>
             &nbsp;<a href="flow.jsp?instanceId=<%=processInstance.getId()%>&id=<%=def.getId()%>&action=cancelInstance">end it</a>
             &nbsp;<a href="log.jsp?instanceId=<%=processInstance.getId()%>">log</a>

        </td>
      </tr>
    <%
  }

  } else {
    %><tr><th colspan=5><big>No instances of previous versions running.</th></tr><%
  }
  %>
</table>


<% executionService.close();%>
<jsp:include page="../partFooter.jsp" />
