<%@ page import="org.jbpm.JbpmServiceFactory,
                 org.jbpm.ExecutionService,
                 org.jbpm.model.definition.Definition,
                 org.jbpm.model.execution.ProcessInstance,
                 org.jbpm.model.execution.impl.ProcessInstanceImpl,
                 java.util.Map,
                 java.util.List,
                 java.util.Iterator,
                 org.jbpm.model.execution.Token,
                 org.jbpm.JbpmQuery,
                 org.jbpm.model.definition.impl.MilestoneImpl"%>
<jsp:include page="../partHeader.jsp" />
<%
  Long id = new Long(request.getParameter("id"));
  JbpmServiceFactory fact = JbpmServiceFactory.getInstance();

    //notice that in this case actorId is totally ignored; hence it may well be null ( :-( )
    ExecutionService executionService = fact.openExecutionService(null);
    ProcessInstance pi = executionService.getProcessInstance(id);
    Definition def = pi.getDefinition();

 if ("step".equals(request.getParameter("action"))) {
    Token t = executionService.getToken(new Long(request.getParameter("tokenId")));
    String transition = request.getParameter("transitionName");
    if (transition!=null && transition.trim().length()>0)
      executionService.endOfState(t.getId(),null,transition);
    else
      executionService.endOfState(t.getId());
    }




  %>
      <table width="90%" align="center" border="1">
        <tr>
          <th colspan=7> <big><%=def.getName()%> ver. <%=def.getVersion()%></big> <small>(id: <%=pi.getId()%>)</small><br>
          list of available tokens:<br></th>
        </tr>
        <tr>
          <th>ID</th>

          <th> NAME</th>
          <th> ACTOR</th>
          <th> STATE</th>
          <th> START - END</th>
          <th> edit</th>
        </tr>


  <%


  String hql = "select from "+Token.class.getName()+" as p where p.processInstance = :instance" ;
  JbpmQuery j = new JbpmQuery( hql );
  j.addParameter("instance",pi);
  List tokensForInstance = executionService.findByQuery(j);

    if (tokensForInstance != null && tokensForInstance.size() > 0) {
      for (Iterator iterator = tokensForInstance.iterator(); iterator.hasNext();) {
        Token t = (Token)iterator.next();
        if (!t.hasEnded() && t.getState()!=null) {
        %><tr>
        <td><%=t.getId()%></td>
        <td><%=t.getName()%></td>
        <td><%=t.getActorId()%></td>
        <td><%=t.getState()!=null ? t.getState().getName() : "no state"%></td>
        <td><%=t.getStart()%>&nbsp;/&nbsp;<%=t.getEnd()%></td>
        <td><%
        if (t.getState() instanceof MilestoneImpl) {
          %>milestone - cannot be edited<%
        } else {
          %><a href="token.jsp?id=<%=t.getId()%>">edit</a><%
        }
        %></td></tr ><%
        }
      }
    } else {
    %><tr> <td colspan=7>No tokens available</td> </tr> <%
  }
    %>


  <%--
  //THIS WAY IT DOESN'T WORK: ???
  Token superProcessToken = pi.getSuperProcessToken();
  if (superProcessToken!=null) {

    Map tokensForInstance = superProcessToken.getChildren();

    if (tokensForInstance != null && tokensForInstance.size() > 0) {
      for (Iterator iterator = tokensForInstance.keySet().iterator(); iterator.hasNext();) {
        String s = (String) iterator.next();
        Token t = (Token)tokensForInstance.get(s);
        %><tr>
        <td><%=t.getId()%></td>
        <td><%=s%></td>
        <td><%=t.getName()%></td>
        <td><%=t.getActorId()%></td>
        <td><a href="token.jsp?id=<%=t.getId()%>">edit</a></td>
        </tr>
        <%
      }
    }
  } else {
    %><tr> <td colspan=5>No tokens available</td> </tr> <%
  }--%>

   <tr>
      <td colspan=7>
      <a href="../index.jsp">home</a> &nbsp;&nbsp;
      <a href="deployList.jsp">deployed flows</a>&nbsp;&nbsp;
      <a href="flow.jsp?id=<%=def.getId()%>">instances</a>&nbsp;&nbsp;
      <a href="nodes.jsp?id=<%=def.getId()%>">nodes</a>&nbsp;&nbsp;
    </tr>


</table>
<% executionService.close();%>
<jsp:include page="../partFooter.jsp" />
