<%@ page import="org.jbpm.JbpmServiceFactory,
                 org.jbpm.ExecutionService,
                 org.jbpm.model.definition.Definition,
                 org.jbpm.model.execution.ProcessInstance,
                 org.jbpm.model.execution.impl.ProcessInstanceImpl,
                 java.util.Map,
                 java.util.List,
                 java.util.Iterator,
                 org.jbpm.model.execution.Token,
                 org.jbpm.JbpmQuery,
                 org.jbpm.model.definition.impl.MilestoneImpl,
                 org.jbpm.model.definition.Swimlane,
                 org.jbpm.model.log.InvocationLog"%>
<jsp:include page="../partHeader.jsp" />
<%
  Long id = new Long(request.getParameter("instanceId"));
  JbpmServiceFactory fact = JbpmServiceFactory.getInstance();

    //notice that in this case actorId is totally ignored; hence it may well be null ( :-( )
    ExecutionService executionService = fact.openExecutionService(null);
    ProcessInstance pi = executionService.getProcessInstance(id);
    Definition def = pi.getDefinition();
  %>
      <table width="90%" align="center" border="1">
        <tr>
          <th colspan=5> <big><%=def.getName()%> ver. <%=def.getVersion()%> logs</big> <small>(id: <%=pi.getId()%>)</small><br>
        </tr>
        <tr>
          <th>ID</th>
          <th> ACTOR</th>
          <th> DATE</th>
          <th> STEP</th>
          <th> METHOD</th>
        </tr>
  <%

  String hql = "select from "+InvocationLog.class.getName()+" as il where il.token.processInstance=:pi order by il.date";
  JbpmQuery j = new JbpmQuery( hql );
  j.addParameter("pi",pi);
  List logs = executionService.findByQuery(j);

    if (logs != null && logs.size() > 0) {
      for (Iterator iterator = logs.iterator(); iterator.hasNext();) {
        InvocationLog il = (InvocationLog)iterator.next();
        %><tr>
        <td><%=il.getId()%></td>
        <td><%=il.getActorId()%></td>
        <td><%=il.getDate()%></td>
        <td><%=il.getToken().getName()%></td>
        <td><%=il.getServiceMethod()%></td>
        <%
      }
    } else {
    %><tr> <td colspan=5>No logs available</td> </tr> <%
  }
    %>


   <tr>
      <td colspan=5>
      <a href="../index.jsp">home</a> &nbsp;&nbsp;
      <a href="deployList.jsp">deployed flows</a>&nbsp;&nbsp;
      <a href="flow.jsp?id=<%=def.getId()%>">instances</a>&nbsp;&nbsp;
      <a href="nodes.jsp?id=<%=def.getId()%>">nodes</a>&nbsp;&nbsp;
    </tr>


</table>
<% executionService.close();%>
<jsp:include page="../partFooter.jsp" />
