<%@ page import="org.jbpm.JbpmServiceFactory,
                 org.jbpm.ExecutionService,
                 org.jbpm.JbpmQuery,
                 org.jbpm.model.execution.impl.ProcessInstanceImpl,
                 org.jbpm.model.definition.*,
                 java.util.*,
                 org.jbpm.model.definition.impl.NodeImpl,
                 org.jbpm.model.definition.impl.TransitionImpl"%>
<%!
  void surfTree(Node current, List tree, Definition def) {
    if (current==null || tree.contains(current))
      return;
    tree.add(current);
    Collection lt = current.getLeavingTransitions();
    if (lt != null && lt.size() > 0) {
      for (Iterator iterator = lt.iterator(); iterator.hasNext();) {
        TransitionImpl transition = (TransitionImpl) iterator.next();
        if (!transition.getTo().equals(def.getEndState()))
          surfTree(transition.getTo(),tree,def);
      }
    }
  }

%> <jsp:include page="../partHeader.jsp" /> <%

  Long id = new Long(request.getParameter("id"));
  JbpmServiceFactory fact = JbpmServiceFactory.getInstance();
  ExecutionService executionService = fact.openExecutionService(null);
  Definition def = executionService.getDefinition(id);
  def = executionService.getLatestDefinition(def.getName());
  List sn = new ArrayList();
  surfTree(def.getStartState(),sn,def);
  sn.add(def.getEndState());
%>
        <table width="90%" align="center" border="1">
          <tr>
            <th colspan=5><big><%=def.getName()%></big> <br>
                          <%=def.getDescription()%>
            </th>
          </tr>
          <tr>
            <th>id</th>
            <th>name</th>
            <th>swimlane</th>
            <th>transitions</th>
          </tr>
      <%

        for (Iterator iterator = sn.iterator(); iterator.hasNext();) {
          Node node = (Node) iterator.next();
          Swimlane sl=null;
          if (node instanceof State){
            sl=((State)node).getSwimlane();
          }
     %>
      <tr>
        <td> <%=node.getId()%> </td>
        <td> <%=node.getName()%> </td>
        <td> <%=(sl!=null ? sl.getName():"")%> </td>
        <td>
          <%
          Collection lec= node.getLeavingTransitions();
          for (Iterator ite = lec.iterator(); ite.hasNext();) {
            Transition transition  = (Transition) ite.next();
            String transname=transition.getName();
            Node dest=transition.getTo();
            %><%=(transname !=null ? transname+" : ":"")+ (dest !=null ? dest.getName():"")%><br><%
          }
          %>
        </td>

      </tr>
    <% } %>
    <tr>
  <td colspan=5>
  <a href="../index.jsp">home</a> &nbsp;&nbsp;
  <a href="deployList.jsp">deployed flows</a> &nbsp;&nbsp;
  <a href="flow.jsp?id=<%=def.getId()%>">instances</a>
</tr>
</table>
<% executionService.close();%>
<jsp:include page="../partFooter.jsp" />

