<%@ page import="org.jbpm.JbpmServiceFactory,
                 org.jbpm.ExecutionService,
                 java.util.List,
                 java.util.Iterator,
                 org.jbpm.model.definition.Definition,
                 java.util.Collection,
                 java.io.InputStream,
                 java.io.FileInputStream,
                 org.jbpm.par.ArchiveBuilder,
                 java.util.jar.JarInputStream,
                 org.jbpm.DefinitionService"%>
<jsp:include page="../partHeader.jsp" />
<%
  if ("add".equals(request.getParameter("action"))) {

    String resource = request.getParameter("file");

    InputStream is = new FileInputStream(resource);
    ArchiveBuilder ab = new ArchiveBuilder(is);
    JarInputStream jis = ab.getJarInputStream();

    // deploy the process
    DefinitionService ds = JbpmServiceFactory.getInstance().openDefinitionService();
    ds.deployProcessArchive(jis);
    ds.close();

  }

    %>
      <table width="90%" align="center" border="1">
        <tr>
          <th colspan=5> <big>deployed flows</big></th>
        </tr>
        <tr>
          <th> id</th>
          <th> version</th>
          <th> name</th>
          <th> nodes</th>
          <th> edit</th>
        </tr>
    <%

  JbpmServiceFactory fact = JbpmServiceFactory.getInstance();

  //notice that in this case actorId is totally ignored; hence it may well be null ( :-( )
  ExecutionService executionService = fact.openExecutionService(null);

  Collection allDefinitions = executionService.getLatestDefinitions();
  if (allDefinitions != null && allDefinitions.size() > 0) {
    for (Iterator iterator = allDefinitions.iterator(); iterator.hasNext();) {
      Definition definition = (Definition) iterator.next();
      %><tr>
        <td><%=definition.getId()%></td>
        <td><%=definition.getVersion()%></td>
        <td><%=definition.getName()%></td>
        <td><a href="nodes.jsp?id=<%=definition.getId()%>">nodes</a></td>
        <td><a href="flow.jsp?id=<%=definition.getId()%>">edit</a></td>
        </tr>
      <%
    }
  } else {
    %> <tr><td colspan="5">no flow deployed. </td></tr> <%
  }
    %>
 <tr><td colspan="5">


  <form action="deployList.jsp" method="POST">
  deploy a new jpdl definition: <input type="text" size="50" name="file"><input type="SUBMIT" name="action" value="add">
  </form>
  </td>
</tr>
  <td colspan=5> <a href="../index.jsp">home</a> &nbsp;&nbsp; </td>
</tr>

</table>
<% executionService.close();%>
<jsp:include page="../partFooter.jsp" />
