<%@ page import="org.jbpm.JbpmServiceFactory,
                 org.jbpm.ExecutionService,
                 java.util.Collection,
                 java.util.Iterator,
                 org.jbpm.model.execution.Token,
                 org.jbpm.model.execution.ProcessInstance,
                 org.jbpm.JbpmQuery,
                 java.util.List,
                 java.io.InputStream,
                 java.io.FileInputStream,
                 org.jbpm.par.ArchiveBuilder,
                 java.util.jar.JarInputStream,
                 org.jbpm.DefinitionService,
                 org.jbpm.model.definition.impl.ActionImpl,
                 org.jbpm.model.definition.impl.TransitionImpl,
                 org.jbpm.model.definition.*"%>
<jsp:include page="../partHeader.jsp" />
<%
  String target = "instance.jsp";
  if (request.getParameter("target")!=null)
    target = request.getParameter("target");

  Long id = new Long(request.getParameter("id"));
  JbpmServiceFactory fact = JbpmServiceFactory.getInstance();

  ExecutionService executionService = fact.openExecutionService(null);
  Token t = executionService.getToken(id);
  executionService = fact.openExecutionService(t.getActorId());
  ProcessInstance pi = t.getProcessInstance();
  Definition def = pi.getDefinition();

  State state = t.getState();
  List actions = state.getActions();

  Collection leavingTransitions = state.getLeavingTransitions();
  Swimlane sw = state.getSwimlane();

%>
        <table width="90%" align="center" border="1">
          <tr>
            <td>
<big><%=state.getName()%> </big> &nbsp;&nbsp; <small>(token <%=t.getId()%> <%=t.getName()%>)</small> <br>
actor: <%=t.getActorId()%>&nbsp;&nbsp; swimlane: <%=sw!=null ? sw.getName() : "no swimlane"%><br>
</td>
</tr>
<tr><td>

<%
  if (actions != null && actions.size() > 0) {
    %>available actions:<br><%
    for (Iterator iterator = actions.iterator(); iterator.hasNext();) {
      ActionImpl action = (ActionImpl) iterator.next();
      %>&nbsp;&nbsp;<%=action.getEventType()%>&nbsp;&nbsp;<small>(id: <%=action.getId()%>)</small><br><%
    }
  } else {
    %><br>no actions available<br><%
  }
%>
      </tr>
<tr><td>
<%
  if (leavingTransitions != null && leavingTransitions.size() > 0) {
    %>available leaving transitions:<br><%
    for (Iterator iterator = leavingTransitions.iterator(); iterator.hasNext();) {
      TransitionImpl trans = (TransitionImpl) iterator.next();
      Node to = trans.getTo();
      %>&nbsp;&nbsp;<%=trans.getId()%>&nbsp;<%=trans.getName()%>&nbsp;<%=trans.getDescription()%><%
      if (to!=null) {
        %> &nbsp;to: <%=to.getId()%>&nbsp;<%=to.getName()%> <%
      }
      if (!t.hasEnded()) {
      %>&nbsp;&nbsp;<a href="<%=target%>?id=<%=pi.getId()%>&tokenId=<%=t.getId()%>&action=step<%=trans.getName()!=null ? "&transitionName="+trans.getName() : ""%>"
      >do step</a><br><%
      }
        
    }
  } else {
    %><br>no transitions available<br><%
  }
%>


</td>
<%
  if (target.equals("instance.jsp")) {
%>
<tr>
  <td colspan=6>
  <a href="../index.jsp">home</a> &nbsp;&nbsp;
  <a href="deployList.jsp">deployed flows</a>&nbsp;&nbsp;
  <a href="flow.jsp?id=<%=def.getId()%>">instances</a>&nbsp;&nbsp;
  <a href="nodes.jsp?id=<%=def.getId()%>">nodes</a>&nbsp;
  <a href="instance.jsp?id=<%=pi.getId()%>">instance</a>&nbsp;&nbsp;
</tr>
<%
  }
%>
</table>
<% executionService.close();%>
<%
  if (target.equals("instance.jsp")) {
%>
<jsp:include page="../partFooter.jsp" />
<%
  }
%>