<%@ page import="org.jbpm.ExecutionService,
                 java.util.Collection,
                 java.util.Iterator,
                 org.jbpm.model.execution.Token,
                 org.jbpm.JbpmServiceFactory,
                 java.util.List,
                 org.jbpm.JbpmQuery,
                 org.jbpm.model.definition.Swimlane"%>
<jsp:include page="partHeader.jsp" />
<%
   JbpmServiceFactory fact = JbpmServiceFactory.getInstance();
   ExecutionService executionService = fact.openExecutionService(null);

  String hql = "select from "+Swimlane.class.getName();
  JbpmQuery j = new JbpmQuery( hql );

  List swims = executionService.findByQuery(j);


%>
 <table width="90%" align="center" border="1">
          <tr><td><big>Flowork - your worklist</big></td></tr>

<tr><td>Available swimlanes:</td></tr>
<%
  if (swims != null && swims.size() > 0) {
    for (Iterator iterator = swims.iterator(); iterator.hasNext();) {
      Swimlane swimlane = (Swimlane) iterator.next();
      %><tr><td><a href="client.jsp?swimlane=<%=swimlane.getName()%>">see work lisf of: <%=swimlane.getName()%></a></td></tr><%
    }
  }

  String swimlane = request.getParameter("swimlane");



  %><tr><td><form action="client.jsp" method="POST">
or see actor/swimlane delegation: <input type="text" size="10" name="swimlane" value="<%=swimlane!=null ? swimlane : ""%>">
<input type="SUBMIT" name="action" value="my work list">
</form></td></tr><%

    if ("step".equals(request.getParameter("action"))) {
      Token t = executionService.getToken(new Long(request.getParameter("tokenId")));
      String transition = request.getParameter("transitionName");

      if (transition!=null && transition.trim().length()>0)
        executionService.endOfState(t.getId(),null,transition);
      else
        executionService.endOfState(t.getId());
      %><tr><td><big>Step performed.</big></td></tr><%
    }

    if (swimlane!=null) {

    Collection tasks = executionService.getTaskList(swimlane);

    %><tr><td><big><%=swimlane%> works:</big></td></tr><%

    if (tasks != null && tasks.size() > 0) {
      for (Iterator iterator = tasks.iterator(); iterator.hasNext();) {
        Token t = (Token) iterator.next();
        if (!t.hasEnded() && t.getState()!=null) {
        %><tr><td><jsp:include page="backoffice/token.jsp">
          <jsp:param name="target" value="client.jsp" />
          <jsp:param name="id" value="<%=t.getId()%>" />
          </jsp:include></td></tr><%
        }
      }
    }
  }

%><% executionService.close();%>
<tr><td><a href="index.jsp">home</a></td></tr>
</table>

<jsp:include page="partFooter.jsp" />
